# Score Reset
execute as @a unless score @s hcuwCraft matches 0.. run scoreboard players set @s hcuwCraft 0
scoreboard players set @a hcuwWandId 0
scoreboard players set @a hcuwBlock 0
scoreboard players remove @a[scores={hcuwBooks=1..}] hcuwBooks 1
# Version Trigger
execute as @a[scores={hcuwVersion=1}] run tellraw @s [{"text":"[","color":"gray"},{"text":"UsefulWands","color":"light_purple"},{"text":"]","color":"gray"},{"text":" Datapack Version : v1.1","color":"white"}]
execute as @a[scores={hcuwVersion=1}] run scoreboard players set @s hcuwVersion 0
# Wand Detection
scoreboard players set @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{Tags:["hcuwWand1"]}}}] hcuwWandId 1
scoreboard players set @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{Tags:["hcuwWand2"]}}}] hcuwWandId 2
scoreboard players set @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{Tags:["hcuwWand3"]}}}] hcuwWandId 3
scoreboard players set @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{Tags:["hcuwWand4"]}}}] hcuwWandId 4
scoreboard players set @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{Tags:["hcuwWand5"]}}}] hcuwWandId 5
scoreboard players set @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{Tags:["hcuwWand6"]}}}] hcuwWandId 6
scoreboard players set @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{Tags:["hcuwWand7"]}}}] hcuwWandId 7
# Hunger to Scoreboard
execute as @a[scores={hcuwWandId=1..}] unless entity @s[nbt={Inventory:[{tag:{Tags:["hcuwMagicoal"]}}]}] run scoreboard players set @s hcuwMagicoal 0
execute as @a[scores={hcuwWandId=1..},nbt={Inventory:[{tag:{Tags:["hcuwMagicoal"]}}]}] run scoreboard players set @s hcuwMagicoal 1
# Individual Wand Reset (If the player isn't using that wand, it's score will reset)
execute as @a[scores={hcuwWandId=1..}] unless score @s hcuwWandId matches 1 run scoreboard players set @s hcuwUseWand1 0
execute as @a[scores={hcuwWandId=1..}] unless score @s hcuwWandId matches 2 run scoreboard players set @s hcuwUseWand2 0
execute as @a[scores={hcuwWandId=1..}] unless score @s hcuwWandId matches 3 run scoreboard players set @s hcuwUseWand3 0
execute as @a[scores={hcuwWandId=1..}] unless score @s hcuwWandId matches 4 run scoreboard players set @s hcuwUseWand4 0
execute as @a[scores={hcuwWandId=1..}] unless score @s hcuwWandId matches 5 run scoreboard players set @s hcuwUseWand5 0
execute as @a[scores={hcuwWandId=1..}] unless score @s hcuwWandId matches 6 run scoreboard players set @s hcuwUseWand6 0
execute as @a[scores={hcuwWandId=1..}] unless score @s hcuwWandId matches 7 run scoreboard players set @s hcuwUseWand7 0
# Wandy Bench Functions
execute as @e[type=item,nbt={Item:{tag:{Tags:["hcuwModifier"]}}}] run tag @s add hcuwModifier
execute if entity @e[tag=hcuwModifier] run function usefulwands:wandy_bench/create_wandy_bench
execute if entity @e[tag=hcuwWandyBench] run function usefulwands:wandy_bench/wandy_bench
# Spawn Projectile
execute as @a[scores={hcuwUseWand1=2,hcuwMagicoal=1}] unless entity @s[nbt={Inventory:[{id:"minecraft:torch"}]}] run tellraw @s [{"text":"[","color":"gray"},{"text":"UsefulWands","color":"light_purple"},{"text":"]","color":"gray"},{"text":" You have no torches in your inventory.","color":"red"}]
execute as @a[scores={hcuwUseWand1=2,hcuwMagicoal=1},nbt={Inventory:[{id:"minecraft:torch"}]}] at @s run summon minecraft:armor_stand ~ ~ ~ {Marker:1b,Invisible:1b,Invulnerable:1b,Tags:["hcuwWandProj1","hcuwProj"]}
execute as @a[scores={hcuwUseWand1=2,hcuwMagicoal=1}] at @s unless entity @s[nbt={Inventory:[{id:"minecraft:torch"}]}] run playsound minecraft:block.note_block.harp master @s ~ ~ ~ 1 0.5
execute as @a[scores={hcuwUseWand2=2,hcuwMagicoal=1}] at @s run summon minecraft:armor_stand ~ ~ ~ {Marker:1b,Invisible:1b,Invulnerable:1b,Tags:["hcuwWandProj2","hcuwProj"]}
execute as @a[scores={hcuwUseWand3=2,hcuwMagicoal=1}] at @s run summon minecraft:armor_stand ~ ~ ~ {Marker:1b,Invisible:1b,Invulnerable:1b,Tags:["hcuwWandProj3","hcuwProj"]}
execute as @a[scores={hcuwUseWand4=2,hcuwMagicoal=1}] at @s run summon minecraft:armor_stand ~ ~ ~ {Marker:1b,Invisible:1b,Invulnerable:1b,Tags:["hcuwWandProj4","hcuwProj"]}
execute as @a[scores={hcuwUseWand5=2,hcuwMagicoal=1,hcuwBlock=0}] at @s run playsound minecraft:block.note_block.harp master @s ~ ~ ~ 1 0.5
execute as @a[scores={hcuwUseWand5=2,hcuwMagicoal=1}] at @s run tag @s add hcuwConstructing
execute as @a[scores={hcuwUseWand6=2,hcuwMagicoal=1}] at @s run summon minecraft:armor_stand ~ ~ ~ {Marker:1b,Invisible:1b,Invulnerable:1b,Tags:["hcuwWandProj6","hcuwProj"]}
execute as @a[scores={hcuwUseWand7=2,hcuwMagicoal=1}] at @s run summon minecraft:armor_stand ~ ~ ~ {Marker:1b,Invisible:1b,Invulnerable:1b,Tags:["hcuwWandProj7","hcuwProj"]}
# Construct Wand Function (Needed Because of complexitiy)
execute if entity @a[tag=hcuwConstructing] run function usefulwands:wands/construct_wand
# Magicoal Fuel Use
execute as @a[scores={hcuwUseWand1=2},nbt={Inventory:[{id:"minecraft:torch"}]}] run clear @s stick{CustomModelData:2680004} 1
execute as @a[scores={hcuwUseWand2=2,hcuwMagicoal=1}] run clear @s stick{Tags:["hcuwMagicoal"]} 1
execute as @a[scores={hcuwUseWand3=2,hcuwMagicoal=1}] run clear @s stick{Tags:["hcuwMagicoal"]} 1
execute as @a[scores={hcuwUseWand4=2,hcuwMagicoal=1}] run clear @s stick{Tags:["hcuwMagicoal"]} 1
execute as @a[scores={hcuwUseWand5=2,hcuwMagicoal=1},tag=hcuwOffhandBlock] run clear @s stick{Tags:["hcuwMagicoal"]} 1
execute as @a[scores={hcuwUseWand6=2,hcuwMagicoal=1}] run clear @s stick{Tags:["hcuwMagicoal"]} 1
execute as @a[scores={hcuwUseWand7=2,hcuwMagicoal=1}] run clear @s stick{Tags:["hcuwMagicoal"]} 1
# Wand Custom Sound
execute as @a[scores={hcuwUseWand1=2,hcuwMagicoal=1},nbt={Inventory:[{id:"minecraft:torch"}]}] at @s run playsound minecraft:hcuw.wandprojectile master @a ^ ^2 ^1 1 1 1
execute as @a[scores={hcuwUseWand2=2,hcuwMagicoal=1}] at @s run playsound minecraft:hcuw.wandprojectile master @a ^ ^2 ^1 1 1 1
execute as @a[scores={hcuwUseWand3=2,hcuwMagicoal=1}] at @s run playsound minecraft:hcuw.wandprojectile master @a ^ ^2 ^1 1 1 1
execute as @a[scores={hcuwUseWand4=2,hcuwMagicoal=1}] at @s run playsound minecraft:hcuw.wandprojectile master @a ^ ^2 ^1 1 1 1
execute as @a[scores={hcuwUseWand5=3,hcuwMagicoal=1},tag=hcuwOffhandBlock] at @s run playsound minecraft:hcuw.wandprojectile master @a ^ ^2 ^1 1 1 1
execute as @a[scores={hcuwUseWand6=2,hcuwMagicoal=1}] at @s run playsound minecraft:hcuw.wandprojectile master @a ^ ^2 ^1 1 1 1
execute as @a[scores={hcuwUseWand7=2,hcuwMagicoal=1}] at @s run playsound minecraft:hcuw.wandprojectile master @a ^ ^2 ^1 1 0.75 1
# Projectile Function (Runs only if a projectile exists)
execute if entity @e[tag=hcuwProj] run function usefulwands:projectile
# Wand Delay
scoreboard players add @a[scores={hcuwUseWand1=1..}] hcuwUseWand1 1
scoreboard players add @a[scores={hcuwUseWand2=1..}] hcuwUseWand2 1
scoreboard players add @a[scores={hcuwUseWand3=1..}] hcuwUseWand3 1
scoreboard players add @a[scores={hcuwUseWand4=1..}] hcuwUseWand4 1
scoreboard players add @a[scores={hcuwUseWand5=1..}] hcuwUseWand5 1
scoreboard players add @a[scores={hcuwUseWand6=1..}] hcuwUseWand6 1
scoreboard players add @a[scores={hcuwUseWand7=1..}] hcuwUseWand7 1
# No Magicoal Message
execute as @a[scores={hcuwUseWand1=2,hcuwMagicoal=0}] run tellraw @s [{"text":"[","color":"gray"},{"text":"UsefulWands","color":"light_purple"},{"text":"]","color":"gray"},{"text":" You have no magicoal for casting magic.","color":"red"}]
execute as @a[scores={hcuwUseWand2=2,hcuwMagicoal=0}] run tellraw @s [{"text":"[","color":"gray"},{"text":"UsefulWands","color":"light_purple"},{"text":"]","color":"gray"},{"text":" You have no magicoal for casting magic.","color":"red"}]
execute as @a[scores={hcuwUseWand3=2,hcuwMagicoal=0}] run tellraw @s [{"text":"[","color":"gray"},{"text":"UsefulWands","color":"light_purple"},{"text":"]","color":"gray"},{"text":" You have no magicoal for casting magic.","color":"red"}]
execute as @a[scores={hcuwUseWand4=2,hcuwMagicoal=0}] run tellraw @s [{"text":"[","color":"gray"},{"text":"UsefulWands","color":"light_purple"},{"text":"]","color":"gray"},{"text":" You have no magicoal for casting magic.","color":"red"}]
execute as @a[scores={hcuwUseWand5=2,hcuwMagicoal=0}] run tellraw @s [{"text":"[","color":"gray"},{"text":"UsefulWands","color":"light_purple"},{"text":"]","color":"gray"},{"text":" You have no magicoal for casting magic.","color":"red"}]
execute as @a[scores={hcuwUseWand6=2,hcuwMagicoal=0}] run tellraw @s [{"text":"[","color":"gray"},{"text":"UsefulWands","color":"light_purple"},{"text":"]","color":"gray"},{"text":" You have no magicoal for casting magic.","color":"red"}]
execute as @a[scores={hcuwUseWand7=2,hcuwMagicoal=0}] run tellraw @s [{"text":"[","color":"gray"},{"text":"UsefulWands","color":"light_purple"},{"text":"]","color":"gray"},{"text":" You have no magicoal for casting magic.","color":"red"}]
execute as @a[scores={hcuwUseWand1=2,hcuwMagicoal=0}] at @s run playsound minecraft:block.note_block.harp master @s ~ ~ ~ 1 0.5
execute as @a[scores={hcuwUseWand2=2,hcuwMagicoal=0}] at @s run playsound minecraft:block.note_block.harp master @s ~ ~ ~ 1 0.5
execute as @a[scores={hcuwUseWand3=2,hcuwMagicoal=0}] at @s run playsound minecraft:block.note_block.harp master @s ~ ~ ~ 1 0.5
execute as @a[scores={hcuwUseWand4=2,hcuwMagicoal=0}] at @s run playsound minecraft:block.note_block.harp master @s ~ ~ ~ 1 0.5
execute as @a[scores={hcuwUseWand5=2,hcuwMagicoal=0}] at @s run playsound minecraft:block.note_block.harp master @s ~ ~ ~ 1 0.5
execute as @a[scores={hcuwUseWand6=2,hcuwMagicoal=0}] at @s run playsound minecraft:block.note_block.harp master @s ~ ~ ~ 1 0.5
execute as @a[scores={hcuwUseWand7=2,hcuwMagicoal=0}] at @s run playsound minecraft:block.note_block.harp master @s ~ ~ ~ 1 0.5
# Wand Delay Reset
scoreboard players set @a[scores={hcuwUseWand1=20..}] hcuwUseWand1 0
scoreboard players set @a[scores={hcuwUseWand2=20..}] hcuwUseWand2 0
scoreboard players set @a[scores={hcuwUseWand3=20..}] hcuwUseWand3 0
scoreboard players set @a[scores={hcuwUseWand4=35..}] hcuwUseWand4 0
scoreboard players set @a[scores={hcuwUseWand5=20..}] hcuwUseWand5 0
execute as @a[scores={hcuwUseWand5=6..,hcuwBlock=1..}] run scoreboard players set @s hcuwUseWand5 0
scoreboard players set @a[scores={hcuwUseWand6=20..}] hcuwUseWand6 0
scoreboard players set @a[scores={hcuwUseWand7=60..}] hcuwUseWand7 0
# Reg. Crafting (Wandy Bench Modifier)
kill @e[type=item,nbt={Item:{id:"minecraft:knowledge_book"}}]
execute as @a[scores={hcuwCraft=0}] store success score @s hcuwCraft run recipe take @s usefulwands:wandy_bench_modifier
execute as @a[scores={hcuwCraft=1}] store result score @s hcuwBooks run clear @s minecraft:knowledge_book
execute as @a[scores={hcuwCraft=1,hcuwBooks=2..}] run tellraw @s [{"text":"[","color":"gray"},{"text":"UsefulWands","color":"light_purple"},{"text":"]","color":"gray"},{"text":" In order to have no unnecessary knowledge books, ","color":"red"},{"text":"only craft one Wandy Bench Modifier at a time.","bold":true,"color":"red"}]
execute as @a[scores={hcuwBooks=1..}] run give @s minecraft:stick{CustomModelData:2680000,display:{Name:"{\"text\":\"Wandy Bench Modifier\",\"italic\":\"false\",\"color\":\"blue\"}",Lore:["{\"text\":\"Throw this onto an enchanting table\",\"color\":\"gray\",\"italic\":\"false\"}","{\"text\":\" to transform it into a wandy bench.\",\"color\":\"gray\",\"italic\":\"false\"}"]},Recipes:["minecraft:sandstone"],Tags:["hcuwModifier"]}
execute as @a[scores={hcuwCraft=1}] run scoreboard players set @s hcuwCraft 0